from browser import document, window, bind, ajax
import json

FORM = document['form']
INPUT_FIELD = document['input']
OUTPUT_FIELD = document['output']
CONVERT_BUTTON = document['convert-btn']
ALERT_TEXT_ELEMENT = document['alert-text']
ALERT_ELEMENT = document['alert']


@bind(FORM, 'submit')
def disable_submit(event):
    CONVERT_BUTTON.dispatchEvent(window.MouseEvent.new("click"))
    event.preventDefault()


@bind(document['alert'], 'click')
def hide_alert(*_):
    ALERT_TEXT_ELEMENT.innerHTML = ''
    ALERT_ELEMENT.style.display = 'none'


def show_alert(message):
    ALERT_TEXT_ELEMENT.innerHTML = message
    ALERT_ELEMENT.style.display = 'block'


def on_complete(request):
    if request.status == 200 or request.status == 0:
        data = json.loads(request.responseText)
        if 'error' in data:
            show_alert(data['error'])
        else:
            hide_alert()
            OUTPUT_FIELD.innerHTML = data['ipa_code']
            OUTPUT_FIELD.disabled = False
            OUTPUT_FIELD.select()
            OUTPUT_FIELD.disabled = True
    else:
        show_alert('Connection/server error')


@bind(CONVERT_BUTTON, 'click')
def to_IPA(_):
    input_code = INPUT_FIELD.value
    url = FORM.attrs['data-get-url']
    ajax.get(url, data={'input': input_code}, oncomplete=on_complete)
